Loading...
Searching...
No Matches
casacore::FrequencyEngine Class Reference
meas package (libcasa_meas) » MeasUDF_module

More...

`#include <FrequencyEngine.h>`

## Public Member Functions

| FrequencyEngine ()
virtual | ~FrequencyEngine ()
Array< Double > | getArrayDouble (const TableExprId &id, int type)
| Get the values.
Array< MFrequency > | getFrequencies (const TableExprId &id)
| Get the frequencies.
void | handleFrequency (std::vector< TENShPtr > &args, uInt &argnr)
| Handle the argument(s) giving the input frequencies and reference type.
void | setConverter (MFrequency::Types toType)
| Set the MeasConvert object.
void | setDopplerEngine (DopplerEngine &engine)
| Set the possible doppler engine.
void | setRadVelEngine (RadialVelocityEngine &engine)
| Set the possible radial velocity engine.
void | setDirectionEngine (DirectionEngine &engine)
| Set the possible direction engine.
void | setEpochEngine (EpochEngine &engine)
| Set the possible epoch engine.
void | setPositionEngine (PositionEngine &engine)
| Set the possible position engine.
Public Member Functions inherited from casacore::MeasEngine< MFrequency >
| MeasEngine ()
virtual | ~MeasEngine ()
MFrequency::Types | refType () const
| Get the reference type.
Bool | handleMeasType (const TENShPtr &operand, Bool doThrow)
| Handle a doppler reference type.
Record | makeAttributes (typename MFrequency::Types refType, Int valueType=1) const
| Make the expression result attributes.
Public Member Functions inherited from casacore::BaseEngine
| BaseEngine ()
virtual | ~BaseEngine ()
void | adaptForConstant (const IPosition &shapeConstant, uInt nvalues=0)
| Adapt the output shape and dimensionality for possible constant values.
void | extendBase (const BaseEngine &, Bool removeFirstAxis=False)
| Extend the shape (if not empty) with the engine's shape.
const IPosition & | shape () const
| Get the output shape.
Int | ndim () const
| Get the output dimensionality.
const Unit & | unit () const
| Get the unit of the function's result.
const Unit & | inUnit () const
| Get the unit of the expression.
Bool | isConstant () const
| Tell if the expression is constant.

## Private Member Functions

virtual void | handleValues (TableExprNode &operand, const TableExprId &id, Array< MFrequency > &frequencies)
| Let a derive class handle the values.

## Private Attributes

MeasFrame | itsFrame
MeasFrame | itsRVFrame
MFrequency::Convert | itsConverter
EpochEngine * | itsEpochEngine
PositionEngine * | itsPositionEngine
DirectionEngine * | itsDirectionEngine
DopplerEngine * | itsDopplerEngine
RadialVelocityEngine * | itsRadVelEngine

## Additional Inherited Members

Protected Member Functions inherited from casacore::MeasEngine< MFrequency >
void | handleMeasArray (const TENShPtr &operand)
| Handle the operand representing an array of Meas values.
void | handleConstant (const TENShPtr &operand)
| Handle a constant Meas value.
Protected Member Functions inherited from casacore::BaseEngine
virtual void | deriveAttr (const Unit &unit, Int nval)
| Let a derived class derive its attributes.
virtual void | setValueType (Int valueType)
| Let a derived class set its value type.
virtual String | stripMeasType (const String &type)
| Let a derived class strip part of the reference type.
Protected Attributes inherited from casacore::MeasEngine< MFrequency >
Array< MFrequency > | itsConstants
MFrequency::Types | itsRefType
ScalarMeasColumn< MFrequency > | itsMeasScaCol
ArrayMeasColumn< MFrequency > | itsMeasArrCol
Protected Attributes inherited from casacore::BaseEngine
Bool | itsIsConst
IPosition | itsShape
Int | itsNDim
Unit | itsInUnit
Unit | itsOutUnit
TableExprNode | itsExprNode

## Detailed Description

Engine for TaQL UDF Frequency conversions

### Intended use:

Public interface

### Review Status

Test programs:
  tMeas

### Prerequisite

- EngineBase

### Synopsis

FrequencyEngine defines Engines (user defined functions) that can be used in TaQL to convert Measures for frequencies. In this way such derived values appear to be ordinary TaQL functions.

Frequency conversions require a MeasFrame containing sky direction, epoch and position on earth. In TaQL these functions can be called like:

meas.freq ('TOPO', 1GHz, 'LSRK', 'CasA', date(),
[1e6m,1e6m,1e6m], 'WGS84')
casacore::date
TableExprNode date(const TableExprNode &node)
Definition ExprNode.h:1515

which converts the frequency from LSRK to TOPO.

- toref is a single constant string.
- pos can have various value types. A single numeric array is a series of RA,DEC in J2000. If given as a set, the last argument of the set can be the reference types of the values in the set. The values can be strings (indicating planetary objects) or value pairs giving lon,lat. The default reference type is J2000.

All such functions return data with type double and unit Hz.

Frequencies can be given like: [f1,f2,...], fromRef where fromRef is the reference type.

A frequency can also be a table column which usually knows its type. It can also be an expression (e.g. FREQUENCY[0,]) which also knows the type.

### Motivation

It makes it possible to handle measures in TaQL.

Definition at line 97 of file FrequencyEngine.h.

## Constructor & Destructor Documentation

## FrequencyEngine()

casacore::FrequencyEngine::FrequencyEngine | ( |  | ) |

## ~FrequencyEngine()

virtual casacore::FrequencyEngine::~FrequencyEngine | ( |  | ) |

virtual

## Member Function Documentation

## getArrayDouble()

Array< Double > casacore::FrequencyEngine::getArrayDouble | ( | const TableExprId & | id,
|  | int | type )

Get the values.

## getFrequencies()

Array< MFrequency > casacore::FrequencyEngine::getFrequencies | ( | const TableExprId & | id | ) |

Get the frequencies.

## handleFrequency()

void casacore::FrequencyEngine::handleFrequency | ( | std::vector< TENShPtr > & | args,
|  | uInt & | argnr )

Handle the argument(s) giving the input frequencies and reference type.

The frequency can be a column in a table.

## handleValues()

virtual void casacore::FrequencyEngine::handleValues | ( | TableExprNode & | operand,
|  | const TableExprId & | id,
|  | Array< MFrequency > & | positions )

private virtual

Let a derive class handle the values.

Implements casacore::MeasEngine< MFrequency >.

## setConverter()

void casacore::FrequencyEngine::setConverter | ( | MFrequency::Types | toType | ) |

Set the MeasConvert object.

## setDirectionEngine()

void casacore::FrequencyEngine::setDirectionEngine | ( | DirectionEngine & | engine | ) |

Set the possible direction engine.

It can be done only once.

## setDopplerEngine()

void casacore::FrequencyEngine::setDopplerEngine | ( | DopplerEngine & | engine | ) |

Set the possible doppler engine.

It can be done only once.

## setEpochEngine()

void casacore::FrequencyEngine::setEpochEngine | ( | EpochEngine & | engine | ) |

Set the possible epoch engine.

It can be done only once.

## setPositionEngine()

void casacore::FrequencyEngine::setPositionEngine | ( | PositionEngine & | engine | ) |

Set the possible position engine.

It can be done only once.

## setRadVelEngine()

void casacore::FrequencyEngine::setRadVelEngine | ( | RadialVelocityEngine & | engine | ) |

Set the possible radial velocity engine.

It can be done only once.

## Member Data Documentation

## itsConverter

MFrequency::Convert casacore::FrequencyEngine::itsConverter

private

Definition at line 146 of file FrequencyEngine.h.

## itsDirectionEngine

DirectionEngine* casacore::FrequencyEngine::itsDirectionEngine

private

Definition at line 149 of file FrequencyEngine.h.

## itsDopplerEngine

DopplerEngine* casacore::FrequencyEngine::itsDopplerEngine

private

Definition at line 150 of file FrequencyEngine.h.

## itsEpochEngine

EpochEngine* casacore::FrequencyEngine::itsEpochEngine

private

Definition at line 147 of file FrequencyEngine.h.

## itsFrame

MeasFrame casacore::FrequencyEngine::itsFrame

private

Definition at line 144 of file FrequencyEngine.h.

## itsPositionEngine

PositionEngine* casacore::FrequencyEngine::itsPositionEngine

private

Definition at line 148 of file FrequencyEngine.h.

## itsRadVelEngine

RadialVelocityEngine* casacore::FrequencyEngine::itsRadVelEngine

private

Definition at line 151 of file FrequencyEngine.h.

## itsRVFrame

MeasFrame casacore::FrequencyEngine::itsRVFrame

private

Definition at line 145 of file FrequencyEngine.h.

The documentation for this class was generated from the following file:

- meas/MeasUDF/FrequencyEngine.h